import { partition } from "../deps/jsr.io/@std/collections/1.0.9/mod.js";
import { Ty } from "./Ty.js";
export function constantUnion(...members) {
    const [strings, numbers] = partition(members, (v) => typeof v === "string");
    return Ty(() => ({
        anyOf: [
            ...strings.length
                ? [{
                        type: "string",
                        enum: strings,
                    }]
                : [],
            ...numbers.length
                ? [{
                        type: "number",
                        enum: numbers,
                    }]
                : [],
        ],
    }), false);
}
//# sourceMappingURL=constantUnion.js.map