import { Ty } from "./Ty.js";
export function tuple(...elements) {
    const { length } = elements;
    return Ty((ref) => ({
        type: "object",
        properties: Object.fromEntries(Array.from({ length }, (_0, i) => [i, ref(elements[i])])),
        additionalProperties: false,
        required: Object.keys(Array.from({ length }, (_0, i) => i)),
    }), true, (v) => Array.from({ length }, (_0, i) => elements[i][""].transform(v[i])));
}
//# sourceMappingURL=tuple.js.map