import { object } from "../object.js";
import { number } from "../primitives.js";
import { transform } from "../transform.js";
export const Rgb = object({
    r: number `Between 0 and 255`,
    g: number `Between 0 and 255`,
    b: number `Between 0 and 255`,
});
export const Hex = transform(Rgb, ({ r, g, b }) => `${toHex(r)}${toHex(g)}${toHex(b)}"`);
function toHex(value) {
    return value.toString(16).padStart(2, "0");
}
//# sourceMappingURL=color.js.map