import { none } from "../primitives.js"
import { taggedUnion } from "../taggedUnion.js"
import type { Ty } from "../Ty.js"

export function Option<S extends Ty>(Some: S): ReturnType<
  typeof taggedUnion<{
    Some: S
    None: typeof none
  }>
> {
  return taggedUnion({
    Some,
    None: none,
  })`An option of specified \`some\` type.`
}
